/************************************************************************************/
/*  Program name CAPFAIMP_INVENTORY.sql                                      		*/
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 6 JAN, 2006   NIP Karen         First created                               		*/
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

ALTER TRIGGER FA_INVENTORY_CT1 DISABLE;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAIMP_INVENTORY';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FA_INVENTORY;

BEGIN
	UPDATE
		FA_INVENTORY
	SET	
		INVENTORY_NAME = CAPBRIMP_MAPPING.RenameStr(SUBSTR(INVENTORY_NAME,1,4), INVENTORY_NAME)
	WHERE INVENTORY_NAME IN
		(
		SELECT 
			INVENTORY_NAME
		FROM 
			CRST_FA_INVENTORY
		);
	
	FOR C1 IN Cur_F LOOP
		BEGIN		
			INSERT INTO FA_INVENTORY
			VALUES
			(
			C1.INVENTORY_NAME,
			C1.START_DATE,
			C1.END_DATE,
			C1.RUN_PURGE_FLAG,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),
			C1.LAST_UPDATE_LOGIN,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),
			C1.CREATION_DATE
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;
	
	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/

ALTER TRIGGER FA_INVENTORY_CT1 ENABLE;